class misString str =
  object(self)
    method lastch = String.get str ((String.length str) - 1)
    method as_string = str
  end
;;

let getsfunc fd =
  let result = ref "" in
  let ch = ref ' ' in
  let nomore = ref false in
  let lbuf = ref "" in
  while !nomore = false && !ch <> '\n' do
    let len = Unix.recv fd !lbuf 0 1 [] in
      if len <> 1
      then
        nomore := true
      else
        ch := String.get !lbuf 0;
        (*don't append the newline*)
        if !ch <> '\n' then result := String.concat "" [!lbuf;!result]
  done;
  result;;

class tcpSocket inch outch =
  object(self)
    val infd = Unix.descr_of_in_channel(inch)
    val outfd = Unix.descr_of_out_channel(outch)
    val localbuf = String.create 2048
    method send ~buf = Unix.send outfd buf 0 (String.length buf) []
    method send ~buf:misString = send buf#as_string
    method recv =
      let len = Unix.recv infd localbuf 0 (String.length localbuf) [] in
      String.copy localbuf
    method gets = getsfunc infd
    method puts str:misString =
      if str#lastch <> '\n' then send (concat "" [str#as_string;"\n"]) else send
      str
  end
;;
