open Misdir;;

exception UsageException;;

let getTypelist =
	let arglist = Array.to_list Sys.argv in
		match arglist with
				first::next::rest -> Misdir.ftypelist_from_stringlist rest []
			| first::next -> raise UsageException
			| [] -> raise UsageException;;

let dname = (Array.get Sys.argv 1) in
let dlist = ref [dname] in
	begin
		Misdir.getFilesystemNames (Array.get Sys.argv 1) getTypelist dlist;
		List.iter print_endline (List.sort String.compare !dlist)
	end
;;
