open Mislib

module RequestDescriptor =
  struct

class requestDescriptor =
  object (self)
    val mutable rid = ""
    val mutable host = ""
    val mutable examiningUrl = ""
    val mutable complete = false
    val mutable accept = false
    method setrid r = rid <- r
    method getrid = rid
    method sethost h = host <- h
    method gethost = host
    method setcomplete = complete <- true
    method setaccept = accept <- true
    method boolAsString b = if b then "true" else "false" 
    method asString = "rid=" ^ rid ^ ",host=" ^ host ^ ",url=" ^ examiningUrl ^
    "complete=" ^ self#boolAsString complete ^ "accept=" ^ self#boolAsString accept
    method url = if complete then "http://" ^ host else examiningUrl
  end
;;

(*of module*)
end
;;
